package heimaufgaben;
import java.io.*;
import java.lang.*;
import java.net.*;
import java.nio.*;
import java.security.*;
import java.util.*;
import java.text.*;

public class Client {

    public Client() throws IOException {

        // Lokale Variablen (Nach Konstruktor nicht mehr nötig)
        String ip = "";
        int port = -1;
        Socket clientSocket;

        // Eingaben müssen aufgenommen werden:
        BufferedReader info = new BufferedReader(new InputStreamReader(System.in)); //Eingabe von IP und Port, später Methodenaufrufe
        System.out.println("IP-Adresse?");
        ip = info.readLine();
        System.out.println("Port?");
        String portFragezeichen = info.readLine();  // Port ist vorerst String

        // Port muss vom String zum Int werden:
        try {
            port = Integer.parseInt(portFragezeichen);
        } catch (NumberFormatException e) { // Falls er keine Zahl ist
            System.err.println("Der Port ist keine Zahl!");
            return;
        }

        // Wenn falsche IP oder port eingegeben wird:
        if (!ip.equals("127.0.0.1")) {
            if (!ip.equals("localhost")) {
                System.err.println("Falsche IP!");
                return;
            }
        }
        if (port != 2022) {
            System.err.println("Falscher Port!");
            return;
        }

        // Verbindungsversuch:
        try {
            clientSocket = new Socket(ip, port);
        } catch (IOException e) {
            System.err.println("Fehler bei clientSocket-Erstellung(IOException)\n-> Läuft der Server?");
            return;
        }

        // Erschaffung von Kommunikationsverbindung:
        BufferedWriter zumServer;
        BufferedReader vomServer;
        try {
            zumServer = new BufferedWriter(new OutputStreamWriter(clientSocket.getOutputStream()));
            vomServer = new BufferedReader(new InputStreamReader(clientSocket.getInputStream()));
        } catch (IOException e) {
            System.err.println("Problem beim Bufferedwriter(IOException)");
            return;
        }

        // Eingaben werden aufgenommen und bearbeitet bis "close":
        System.out.println("Verbindung hergestellt. erwarte Auftrag:");
        while (clientSocket.isConnected()) {
            String eingabe = "";
            String ausgabe = "";
            try {
                eingabe = info.readLine();
                zumServer.write(eingabe + "\n"); // Alles wird an den Server geschickt
                zumServer.flush();
                ausgabe = vomServer.readLine();  // Ausgabe vom Server wird verglichen
            } catch (IOException e) {
                System.err.println("Probleme bei der Nachrichtenübermittlung an Server");
            }
            if (ausgabe.equals("EXIT")) {
                System.out.println(ausgabe);
                info.close();   // Exit beendet alle Schnittstellen mit Server
                clientSocket.close();
                break;  // Abbruch des while loops
            } else if (ausgabe.length()>3 && ausgabe.substring(0, 4).equals("ECHO")) {
                System.out.println(ausgabe.substring(5));
            } else if (ausgabe.length()>3 && ausgabe.substring(0, 4).equals("TIME")) {
                System.out.println(ausgabe.substring(5));
            } else if (ausgabe.length()>3 && ausgabe.substring(0, 4).equals("DATE")) {
                System.out.println(ausgabe.substring(5));
            } else if (ausgabe.length()>4 && ausgabe.substring(0, 5).equals("ERROR")) {
                System.out.println(ausgabe.substring(6));
            } else {    // Bei Ping, Verlauf etc:
                System.out.println(ausgabe);
            }
        }
    }
}
