package heimaufgaben;
import java.io.*;
import java.lang.*;
import java.net.*;
import java.nio.*;
import java.security.*;
import java.util.*;
import java.text.*;

public class Server{
    private boolean runs = false;   // Ist ein Client connected?
    private boolean shutdown = false;   // Möchte ich den server beenden?

    public Server() throws IOException{
        while(!shutdown) {
            if(!runs) {
                runs = true;
                BufferedReader prt = new BufferedReader(new InputStreamReader(System.in));
                System.out.println("Bitte Porteingabe...");
                try{
                    if (Integer.parseInt(prt.readLine()) == 2022) {
                        prt.close();
                        neuerServer();
                    }
                    else {
                        prt.close();
                        System.err.println("Falscher Port, momentan ist nur Port 2022 möglich");
                        runs = false;
                    }
                } catch (NumberFormatException e) {
                    prt.close();
                    System.err.println("Es dürfen nur Zahlen eingegeben werden!");
                    runs = false;
                }
            }
        }
    }

    private void neuerServer(){
        // Lokale Variablen (Nach Methode ist Server beendet)
        Socket serverSocket = null;
        BufferedWriter zumClient;
        BufferedReader vomClient;
        try {
            ServerSocket tempSocket = new ServerSocket(2022);   // Port wird festgelegt
            System.out.println("Warte auf Client...");
            serverSocket = tempSocket.accept(); // Sobald cleint sich verbindet, geht es weiter
            System.out.println("Client hat sich verbunden!");
            tempSocket.close();
        } catch (Exception e) {
            System.err.println("Probleme bei Verbidnungsherstellung zum CLient");
            return;
        }
        ArrayList<String> verlauf = new ArrayList<String>();;  // History
        try{
            zumClient = new BufferedWriter(new OutputStreamWriter(serverSocket.getOutputStream()));
            vomClient = new BufferedReader(new InputStreamReader(serverSocket.getInputStream()));
        } catch (IOException e) {
            System.err.println("Probleme mit dem Bufferedwriter/reader");
            return;
        }

        // Befehle Werden aufgenommen
        System.out.println("Erwarte Eingaben...");
        boolean abbruch = false;
        String eingabe = "";
        while(!abbruch) {
            try{
                eingabe = vomClient.readLine();
                System.out.println("Eingabe vom Client: "+eingabe);
                verlauf.add(eingabe);   // Jede Anfrage wird sich gemerkt
            } catch (IOException e) {
                System.err.println("Probleme beim Lesen der Client-Eingabe");
                abbruch = true;
                try {
                    zumClient.write(" 500 INTERNAL SERVER ERROR\n");
                    zumClient.flush();
                } catch (IOException f) {
                    System.err.println("Zusätzlicher Fehler beim Fehler Report an Client");
                }
            }
            // Jede mögliche Eingabe wird überprüft
            try{
                if(eingabe.equalsIgnoreCase("exit")){
                    abbruch = true;
                    runs = false;   // Server runned nicht mehr, zurück zum Konstruktor
                    zumClient.write("EXIT\n");
                    zumClient.flush();
                    System.out.println("Der Server wird neugestartet");
                    serverSocket.close();
                }
                else if(eingabe.equalsIgnoreCase("ping")) {
                    zumClient.write("PONG\n");
                    zumClient.flush();
                }
                else if(eingabe.equalsIgnoreCase("current time")) {
                    zumClient.write("TIME "+new SimpleDateFormat("hh:mm:ss").format(new Date())+"\n");
                    zumClient.flush();
                }
                else if(eingabe.equalsIgnoreCase("current date")) {
                    zumClient.write("DATE "+new SimpleDateFormat("dd.MM.yyyy").format(new Date())+"\n");
                    zumClient.flush();
                }
                else if(eingabe.equalsIgnoreCase("history")) {
                    String ausg = "Gesamter Verlauf: ";
                    for(int i=0; i<verlauf.size()-1; i++) { // Die gesamte Arraylist wird ausgegeben
                        ausg = ausg.concat(verlauf.get(i)+", ");    // String wird zusammen concatted
                    }
                    ausg = ausg.concat(verlauf.get(verlauf.size()-1)+"\n"); // Nach letztem Element kommt kein Komma, sondern \n
                    zumClient.write(ausg);
                    zumClient.flush();
                }
                else if(eingabe.length()>=4 && eingabe.substring(0,4).equalsIgnoreCase("echo")) {
                    zumClient.write(eingabe.substring(5)+"\n");
                    zumClient.flush();
                }
                else if(eingabe.length()>=9 && eingabe.substring(0,7).equalsIgnoreCase("history")) {
                    int zahl = 0;
                    boolean fehler = false; // Nach fehler = true soll er es nicht weiter versuchen und if abbrechen
                    try{
                        zahl = Integer.parseInt(eingabe.substring(8,eingabe.length()));
                    } catch (NumberFormatException e) {
                        System.out.println("Der Client muss Zahlen hinter history schreiben smh");
                        zumClient.write("ERROR 400 BAD REQUEST\n"); // Bei falschem Aufruf
                        fehler = true;
                    }
                    if (zahl>=verlauf.size() && !fehler) {
                        String ausg = "Gesamter Verlauf: ";
                        for(int i=0; i<verlauf.size()-1; i++) { // Gesamter Verlauf, da es zu wenige Elemente in Verlauf gibt
                            ausg = ausg.concat(verlauf.get(i)+", ");
                        }
                        ausg = ausg.concat(verlauf.get(verlauf.size()-1)+"\n");
                        zumClient.write(ausg);
                    }
                    else {
                        if(zahl>=0 && !fehler) {
                            String ausg = "Verlauf der letzten "+zahl+" Anfragen: ";
                            for(int i=verlauf.size()-zahl; i<verlauf.size()-1; i++) {   // Verlauf ab size-zahl-1 bis size-1
                                ausg = ausg.concat(verlauf.get(i)+", ");
                            }
                            ausg = ausg.concat(verlauf.get(verlauf.size()-1)+"\n"); // Nach letztem Element kein Komma, sondern \n
                            zumClient.write(ausg);
                        }
                        else {

                            if (!fehler) zumClient.write("Super witzig\n");  // Falls Zahl negativ ist
                        }
                    }
                    zumClient.flush();
                }
                else {
                    zumClient.write("ERROR 400 BAD REQUEST\n"); // Bei falschem Aufruf
                    zumClient.flush();
                }

            } catch (IOException | NullPointerException e) {
                System.err.println("Fehler beim schreiben zum Client");
                try {
                    zumClient.write("ERROR  500 INTERNAL SERVER ERROR\n");
                    zumClient.flush();
                } catch (IOException f) {
                    System.err.println("Zusätzlicher Fehler beim Fehler Report an Client");
                }
                abbruch = true;
                runs = false;
            }

        }

    }






    
}
